Worklog:
        
+ : added something
* : fixed/changed something

For 1.1a:
* Broke Visgroups in 1.1 - fixed.
* Paste Special accepted only positive numbers using the keyboard - fixed.
* Problems with the 3D view being updated after manipulating 
  solidentities fixed (improperly textured objects, duplicate objects
  in the 3D view only, etc.) This also caused big memory leaks, which
  are now fixed.
* More errors in quake.fgd fixed.
* Point-entities (player starts, etc) are now snapped to the grid
  at their centerpoints if you move one at a time.

+ You can now move objects by click-and-dragging them in one step.
+ You can COPY objects while moving them by holding down SHIFT before
  you release the left mouse button.
+ New feature - Snap Marked Objects To Grid - use the TOOLS menu or
  Ctrl+B. This feature does not modify the size of the objects or
  their relative positions.

For 1.1:
* The .PTS file is now copied to the id1\maps directory, instead of the
  Quake directory (which was incorrect.)
* The Remove button in the VisGroups editor works now.
* Pressing Ctrl+Z too many times would introduce instabilities, and
  Worldcraft would often crash. Fixed.
* Fixed a bug with the selection box that disallowed resizing.
* Fixed a menu text bug - after editing a prefab and saving it back
  to the library, the file menu would still contain "Update Prefab"
  instead of "Save File".
* The texture browser would start off with tons of black space after
  the textures - fixed. Also caused some crashes - fixed.
* Fixed a bug that caused the Filter Control to reverse the action of
  checking the VisGroups checkbox.
* trigger_setskill listed skills 1-4 - they should have been 0-3.

+ The texture browser looks way better. It also has a filter feature -
  type in the text you want to filter with in the edit box at the 
  bottom, and only those textures that contain the text in their names
  will be displayed. You don't need to press enter here. 
+ Added White On Black color scheme for the 2D windows. Use 
  Tools|Options|2D views to select it.
+ Added highlighted gridlines every 10 grid units.

  New Registered Features:

* Prefab Library was still disabled in the first registered CD.
  Fixed. <duhh>

+ Advanced Run Map dialog. Allows you to create custom build 
  configurations - for example, you can create a "fast" build that
  compiles the map with minimal detail for quick previews, and
  a "release" build that compiles with full detail when you've
  finished your map.
+ Find/Replace textures dialog box. You can select a texture to
  replace in the entire map or just the marked objects.

For 1.0b:
+ Added option to reverse mouse Y axis in the 3d views - just like a
  flight sim.
+ Added default grid size option in the 2d views tab.

For 1.0a (12/05):
* IMPORTANT: Selection hit List cycle keys changed to PGUP and PGDN.
* You can now use the . and DEL keys in the face properties bar (that
  is, you can enter decimal values.)
* Old-style Cut/Copy/Paste shortcuts work again, as does the popup
  mouse menu.
* Couple little UI-caused crashes fixed.
* The "go" button in the Map Check dialog didn't "go" to duplicate
  plane errors. Fixed.
* Setup program didn't install VIS and LIGHT.. oops.

For 1.0 (12/02):
+ Added multiple, unlimited Undo/Redo! Configure the levels of Undo you
  want to save in Tools|Options. Remember - the higher you go, the more
  memory this feature will take up. (It is quite a hog in some cases.)
+ Added more color difference to objects (monsters, etc), and added 
  some missing attributes to some objects.
+ Alt+A and Alt+S also change the grid size.. people with non-english
  keyboards/Win95 installs couldn't use [ and ] (which still work for
  those who can use them.)
+ Added better multi-pick feature. The 3D view works the same way as 
  before - hold down the left button to cycle thru the "hit" objects. 
  The new feature is the use of the , and . keys to cycle backwards and 
  forwards in the Hit List. This also works with 2D views - the left 
  button adds all the "hit" objects to the Hit List, and you can use 
  the PGUP and PGDN keys to cycle thru the objects. Again, hold down CTRL 
  *before* you click to keep the current selection.
+ Added combobox to the Angle field in the Object Properties dialog that
  contains "Up" (angle -1) and "Down" (angle -2).. just a convenience.
+ The Paste Special dialog now saves the info through sessions.
+ Added the ability to hollow "outwards." If you enter a negative number
  in the wall width field of the Hollow dialog, the resultant room will
  be that width larger than the original solid.
+ Carving one object no longer groups that object.
+ Added a window that displays the output of QBSP, LIGHT and VIS before
  Quake is run. It's ugly right now, but it works! The program text 
  appears in chunks, but the programs aren't actually much slower than 
  they normally are (maybe 99% of normal speed.) Will be improved.
+ Added a Clear Flags button to the Flags tab of the Object Properties
  dialog.
+ Added "temporary invisibility" feature. Select some objects, and use
  View|Hide Selected Objects to remove them from view. This is totally
  independant of the Filter Control and VisGroups. To re-display ALL the
  hidden objects, use View|Show Hidden Objects.
+ Added a Map Error Checker. The errors it checks for are currently:
	- no player 1 start
	- solid has mixed face contents.
	- object whose 'target' value has no matching 'targetname' in 
	  another object
  Use Map|Check for Problems or Alt+P to access it.
+ Added "show connections" feature to the View menu. When ON, the 2D
  views display lines from targets to their triggers. 
+ The "round face limit" of cylinders and spikes is now 32.
+ Compiling under DirectX3 now. Might fix up some problems.
+ Added Threewave Capture the Flag entities. They are:
    item_flag_team1, item_flag_team2,
    info_player_team1, info_player_team2
  To use these items, you must install the Threewave CTF patch. Get it
  from http://quake.threewave.com/
+ Added flip (mirror) command. This is relative to the last active 2D 
  view. Use Tools|Flip|Horizontal/Vertical. Hotkeys - Horizontal: Ctrl+L.
  Vertical: Ctrl+I.

* Fixed problems with loading MAPs - loading once and then loading again
  produced an error that wasn't really there.
* Fixed a crash-on-exit bug specific to the last version.
* No more MaxTextures problem.. the limit is now 8192 textures.
* If there was an error with the syntax in QUAKE.FGD, Worldcraft
  would say "There is an error", but fail to report the error message.
  This has been fixed.
* The toEntity feature would display point-entity classes in the object
  properties dialog. This has been fixed: now, only solid-entity classes
  are displayed (as is proper.)
* Using Paste Special's rotate feature with group/entity objects really 
  did not work. Fixed.
* FINALLY got the edit field in the Object Properties dialog box to look
  right.
* Dragging an object past the scroll borders of a map really screwed up
  the display. Fixed.
* Invisible objects are no longer carved.
* AUGH. RMF files did not save the information I carefully cultured for
  faces in 10/22 that prevents leaks (cutnodeportal errors).. this is 
  fixed. How annoying.
* Fixed misalignment problems with 90/180/270/360 degree rotations.

For 10/30:
* Problems with QBSP and paths with spaces (such as "program files", 
  ironically!) are fixed. This caused crashes within QBSP, so the Run
  Map feature didn't work.
* Problems with some crappy 3D cards (no offense!) worked-around. If you 
  have a Matrox Millenium, a Stealth 3D, or another crappy 3D card
  (again, no offense! :) use Tools|Options|3D views and turn off
  "Hardware Acceleration." Don't load any maps before you do this.
* Textured display on pasted objects was all wrong in some cases. Fixed.
* I find it hard to believe I never caught this before.. but the closing
  line for every polygon in the 2D view was not being drawn. Huh???
* Carving with "Filter by Groups" made the results of a carve disappear.
  Fixed.

+ Added "Paste Special" feature. This is pretty handy - it allows you 
  to specify the number of copies to paste, and an accumulative offset/
  rotation vector to modify each pasted object.
+ Added "Draw Vertices" option in the 2d views configuration tab. Use
  Tools|Options to configure Worldcraft!
+ Made small solid handling much better: it's easier to move/modify 
  tiny (4x4x4, for example) solids.
+ Improved visual response when modifying objects: cursor changes to 
  reflect the handle the cursor over in move/scale and shear modes.
+ Now using a proper method to get the Quake/Maps directory in Tools|
  Options|General. 
+ Added spin button controls to the texture application toolbar. Clicking
  these updates the textures right away - there's no goin' back! (Until
  I implement Undo .. what a nasty feature that is.)
+ Important: The file (MAP/RMF) is now ALWAYS saved when you select 
  "run map."

Since 10/07:
* Fixed disappearing dialog box text
* Installation program now uses a standard method to read the Win95/NT4
  Start Menu Directory. Previous version had problems with NT4 and 
  international versions of 95.
* Installation program will now create directories of any depth, such as:
	d:\program files\worldcraft, even if
	d:\program files\ does not exist.
* Texture brightness can now be brighter.
* Fixed inability to re-enable 3D views once they'd been disabled.
* Restructured menus a bit - in particular, the "View" menu now contains
  the Map View 2d/3d commands.
* You can now move the mouse into a view to move the keyboard focus to 
  that view.
* Single-entity selections are no longer resizable - you can just 
  move them.
* Alignment tools were reversed sometimes.. fixed.
* Fixed problems loading commented MAP files.. again. Improved file 
  error handling.
* The carve function now uses the appropriate texture for new faces.
* Export to Quake MAP and Run MAP in Quake crashed if the map was not
  already saved.
* Fixed some object coloring problems.
* Face texture scale values were not always properly saved, because
  Worldcraft neglected to save the fractional portion of a floating 
  point value: 1.5 would be saved as 1, for example, and 0.5 as 0. 
  Oops!
* Some custom texture files did not load properly.. fixed.
* !!! Fixed "Carve" bug that caused leaks !!!

+ Added "2d views" tab to configuration dialog. New options: No Scrollbars,
  Crosshair Cursor, 15 degree default rotation.
+ Added 'map info' function to display the number of solids, entities and
  faces in the map.
+ Added function to center all 2D views on the currently selected objects.
  Use View|Center on Selection, or Ctrl+N.
+ Added more functionality to the Run Map dialog. You can now specify
  LIGHT -extra, QBSP -onlyents, and "Save Visible Objects Only."
+ Added "make hollow" tool. This turns each selected solid into a group of
  solids that forms a hollow object. For example, you can create a cube,
  select Tools|Make Hollow (or press Ctrl+H), and Worldcraft will create
  a series of solids that form a hollow cube. You can do this with any 
  shaped object: blocks, cylinders, spikes, or whatever. Worldcraft will
  ask you to specify the width of the walls.
+ Customized QBSP included with Worldcraft. Supports up to 64 solid faces,
  and will work with multiple texture files. No need to download anythin'
  else.

Since 09/20:
* Fixed a lot of Direct3D crashing bugs. I hope this helps some people.
  Unfortunately, it won't help people with Matrox cards.
* Worldcraft no longer creates "duplicate brush planes", which QBSP 
  would often complain about.
* "Select All" and the box selection would select objects that were not
  visible. Fixed.
* Shearing the selection was all wrong. Fixed.
* The 500 solid limit is removed.
* Entity keyvalues were removed if Smartedit didn't know about them - 
  this wasn't part of the original design, but uh - someone slipped the
  code in there. Or something. Anyway, that's fixed.
* Fixed pasting & object creation. New objects are now created in the
  current 2D view (of course), and are centered in the next most recently
  used view.

+ Added FULL textured preview. The textures in this preview are properly
  aligned, properly rotated and properly scaled. A huge thank you goes
  to Alex Moon (odin@mdn.com) for giving me the Direct3D code to calculate
  the texture coordinates based on Quake information.
+ Added new edit mode: "Apply textures mode." Click the funny looking
  pencil-block icon on the left to activate it. When you're in this mode,
  all you can do is select faces in the 3D view and edit their textures
  and offset/rotation/scaling information.
   
  (Sidetrack: I am adding a "Vertex/face manipulation mode." Watch for
   it in the immediate future!)

  How to use this:

  - Click on a face to select/deselect it.
  - Hold down CTRL to select multiple faces.
  - Hold down SHIFT to select/deselect all of a solid's faces. SHIFT
    must be combined with CTRL to select multiple solids' faces.

  When you enter the mode, a dialog box is displayed that contains info
  about the currently selected faces. Modify the info and hit APPLY to
  make it permanent. Hit REVERT to restore the original information.
  While you're in this mode, you can still use the other tools - magnify,
  camera, etc. However, you MUST select the pointer tool to select more
  faces. Also, You can use Edit|Clear Selection to deselect all faces.

+ Hold down SHIFT to make the right mouse button move forward/backward in
  the 3D view with the camera tool.
+ Added support for multiple texture files. Configure this using Tools|
  Options. NOTE: If you use more than one texture file, you MUST use
  a version of QBSP that supports multiple texture files.
+ Added "Hide Items" menu selection. This toggles the display of items: 
  Monsters, Guns, & so on.
+ Added a spike/cone primitive.
+ Added the ability to select the number of faces to create on a 
  cylinder/spike.
+ Added the ability to add solids to an existing solidentity. Select
  the solids you want to add and the entity you want to add them to, select
  'toEntity', and Worldcraft will ask you if you want to combine the solids 
  & the existing entity or create a new entity.
+ Added mouse scroll feature for the 2D views. Hold down the spacebar
  and left-click-drag to drag the view around. It doesn't track perfectly
  yet, but it will.. oh, it will.
+ The Texture Browser now initially selects the texture that is selected
  on the Texture Bar.
+ Added preset zooms - the 1 thru 9 keys now zoom out->in.
+ Added the ability to save only the visible parts of a MAP. This is very
  useful for cutting down on QBSP/LIGHT time. Select File|Export to Quake
  MAP, and click on "Save Visible Objects Only."
+ The size of the selected objects is now displayed on the status bar.
+ Added gamma-correction keys. CTRL+Home makes textures brighter, and 
  CTRL+End makes textures darker. You can also change this setting with 
  Tools|Options.
+ Added color to the game definition file. Now, different objects appear
  different colors.
+ Upped face limit to 120. Also reduced memory requirements for Solids:
  In the previous version, 16 faces were allocated for each solid regardless
  of how many were actually used. The new version allocates faces as
  necessary in blocks of six: this means big memory savings, at a small
  performance price.
